//////////////////////////////////////////////////////////////////////
/*****************************************************************/
// This file is a part of the AppBuilder MFC Extention Class.
// ?000 UCanCode Software, All Rights Reserved.
// This is only define for UCanCode Software AppBuilder.
//
// UCanCode SOFTWARE GRANTS TO YOU (ONE SOFTWARE PROGRAMMER) THE
// LIMITED RIGHT TO USE THIS SOFTWARE ON A SINGLE COMPUTER FOR EVALUATION
// PURPOSES ONLY. THESE SOURCE FILE ARE CONSIDERED CONFIDENTIONAL AND ARE 
// THE PROPERTY OF UCanCode SOFTWARE AND ARE NOT TO BE RE-DISTRIBUTED
// BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED WRITTEN CONSENT OF 
// UCanCode SOFTWARE.
//
// You can contact us.
// ucancode@263.com
// http://www.ucancode.net
/********************************************************************/
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_AFCYEARSELECTWND_H__E0BC67CC_5483_11DC_A3BF_D4AD141DC353__INCLUDED_)
#define AFX_AFCYEARSELECTWND_H__E0BC67CC_5483_11DC_A3BF_D4AD141DC353__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AFCYearSelectWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// AFCYearSelectWnd window

#define TYPE_0 99
#define TYPE_1 100
#define TYPE_2 101
#define TYPE_3 102
#define TYPE_4 103
#define TYPE_5 104
#define TYPE_6 105
#define TYPE_7 106
///////////////////////////////////////////////////////////////////////
//AFCDayObj
#include <afxtempl.h>

class CMemDC : public CDC 
{
private:
	CBitmap m_bitmap; // Offscreen bitmap
	CBitmap* m_oldBitmap; // bitmap originally found in CMemDC
	CDC* m_pDC; // Saves CDC passed in constructor
	CRect m_rect; // Rectangle of drawing area.
	BOOL m_bMemDC; // TRUE if CDC really is a Memory DC.
public:
	CMemDC(CDC* pDC) : CDC(), m_oldBitmap(NULL), m_pDC(pDC)
	{
		ASSERT(m_pDC != NULL); // If you asserted here, you passed in a NULL CDC.		
		m_bMemDC = !pDC->IsPrinting();				
		if (m_bMemDC)
		{			// Create a Memory DC
			CreateCompatibleDC(pDC);	
			pDC->GetClipBox(&m_rect);
			m_bitmap.CreateCompatibleBitmap(pDC, m_rect.Width(), m_rect.Height());
			m_oldBitmap = SelectObject(&m_bitmap);
			SetWindowOrg(m_rect.left, m_rect.top);	
		} 
		else 
		{
			// Make a copy of the relevent parts of the current DC for printing
			m_bPrinting = pDC->m_bPrinting;		
			m_hDC = pDC->m_hDC;
			m_hAttribDC = pDC->m_hAttribDC;	
		}
	}	
	~CMemDC()
	{	
		if (m_bMemDC)
		{
			// Copy the offscreen bitmap onto the screen.
			m_pDC->BitBlt(m_rect.left, m_rect.top, m_rect.Width(), m_rect.Height(),
				this, m_rect.left, m_rect.top, SRCCOPY);			//Swap back the original bitmap.
			SelectObject(m_oldBitmap);	
		} 
		else 
		{
			m_hDC = m_hAttribDC = NULL;
		}	
	}		// Allow usage as a pointer	
	CMemDC* operator->() 
	{
		return this;
	}	
	// Allow usage as a pointer	
	operator CMemDC*() 
	{
		return this;
	}
};

class AFCDayObj : public CObject  
{
protected:
	DECLARE_SERIAL(AFCDayObj);
public:
	AFCDayObj();
	
	virtual ~AFCDayObj();
	
	//Store the data to the file.
	virtual void Serialize(CArchive &ar);
	
	//Draw the object with normal state.
	void DrawNormal(CDC *pDC);
	
	//Draw the object with select state.
	void DrawSelect(CDC *pDC);
	
	//Draw the object with type state.
	void DrawType(CDC *pDC);
	
	//Draw the object.
	void Draw(CDC *pDC);
public:
	BOOL bSelect;
	CRect rcPosition;
	UINT nType;
	CString strCaption;
	int nDay;
	int nCurMonth;
	int nCurDay;
	int nCurYear;
	CString strJiaName;
	int nCurWeek;
	BOOL bWeek;//ΪTRUEʱΪΪFALSEʱΪ˫
	COLORREF crTextColor;
	COLORREF crBackColor;
};

typedef CTypedPtrList<CObList, AFCDayObj*> AFCDayObjList;

#define     START_YEAR            1583
#define     SIMPLE_STYLE          0
#define     TRADITIONAL_STYLE     1

class AFCYueObj : public CObject  
{
protected:
	DECLARE_SERIAL(AFCYueObj);
public:
	AFCDayObjList* GetObjects() { return &m_objects; }
	AFCYueObj(int nYear = -1, int nMonth = -1, int nDate = -1);
	virtual ~AFCYueObj();
	virtual void Serialize(CArchive &ar);
	void Add(AFCDayObj* pObj);
	void Remove(AFCDayObj* pObj);
	long julday (int mm, int id, int iyyy);
	int  FDOM ();
	BOOL LeapYear ();
	int GetDaysinMonth();
	void ReInit();
	AFCDayObj *FindDay(int nY,int nM,int nD);
	void Draw(CDC *pDC);
	void InitMonth();
	AFCDayObj* HitTest(CPoint &pt);
public:
	int     m_nYear;
    int     m_nMonth;
	int		m_nDate;
	AFCDayObjList m_objects;
	short   nCellHeight;
    short   nCellWidth;
	int     nRows, nColumns, nMargins, nStyle;
	CRect rcPosition;
    CRect   m_rMinus;
    CRect   m_rPlus;
    CRect   m_rYear;
	int nCurDay;
	int nCurMonth;
	int nCurYear;
public:
	void SetDaysBackColor(COLORREF cr) {crBackColor = cr;};
	void SetDaysTextColor(COLORREF cr) { crTextColor = cr;};
	void SetBorderColor(COLORREF cr)   { crBorder = cr;};
	void SetYearBackColor(COLORREF cr) { crTitle = cr;};
	void SetYearBarColor(COLORREF cr)  {crTitleTextColor = cr;};
	void SetWeekBarColor(COLORREF cr)  {crCaptionColor = cr;};
protected:
	COLORREF crBackColor;
	COLORREF crTextColor;
	COLORREF crBorder;
	COLORREF crTitle;
	COLORREF crTitleTextColor;
	COLORREF crCaptionColor;
public:
	virtual BOOL SaveDocument(LPCTSTR lpszPathName);
	virtual BOOL OpenDocument(LPCTSTR lpszPathName);
	CFile *GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
		CFileException* pError);
	virtual void ReleaseFile(CFile* pFile, BOOL bAbort);
	void ChnageYear(int nChangeYear);
	void Reset();
	
};
typedef CTypedPtrList<CObList, AFCYueObj*> AFCYueObjList;
#define YEAR_HEIGHT 25
class AFCYearObj : public CObject  
{
	DECLARE_SERIAL(AFCYearObj);
public:
	void Add(AFCYueObj* pObj);
	void Remove(AFCYueObj* pObj);
	virtual BOOL SaveDocument(LPCTSTR lpszPathName);
	virtual BOOL OpenDocument(LPCTSTR lpszPathName);
	CFile *GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
		CFileException* pError);
	virtual void ReleaseFile(CFile* pFile, BOOL bAbort);
public:
	AFCYearObj();
	AFCYearObj(int nY,CRect rcPos);
	virtual ~AFCYearObj();
	AFCYueObjList m_objects;
	virtual void Serialize(CArchive &ar);
	int nYear;
	CRect rcPosition;
public:
	void InitYear();
	void Draw(CDC *pDC);
	void ChangeYear(int nChangeYear);
	AFCDayObj * HitTest(CPoint &pt);
	AFCDayObj *FindDay(int nY,int nM,int nD);
	void Reset();
	CRect rcLeft;
	CRect rcRight;
	int nCurDay;
	int nCurMonth;
	int nCurYear;
	void SaveData(CString str);
	void ChangeWeek(int nWeek,int nType);
	void ChangeDanWeek(int nWeek,int nType,BOOL bType);
	void ResetCount();
public:
	void SetDaysBackColor(COLORREF cr) {crBackColor = cr;};
	void SetDaysTextColor(COLORREF cr) { crTextColor = cr;};
	void SetBorderColor(COLORREF cr)   { crBorder = cr;};
	void SetYearBackColor(COLORREF cr) { crTitle = cr;};
	void SetYearBarColor(COLORREF cr)  {crTitleTextColor = cr;};
	void SetWeekBarColor(COLORREF cr)  {crCaptionColor = cr;};
protected:
	COLORREF crBackColor;
	COLORREF crTextColor;
	COLORREF crBorder;
	COLORREF crTitle;
	COLORREF crTitleTextColor;
	COLORREF crCaptionColor;
};

#define WM_YEARCHANGE WM_USER+33

class AFCYearSelectWnd : public CWnd
{
	// Construction
public:
	AFCYearSelectWnd();
	
	// Attributes
public:
	BOOL Create(CRect rcPos, CWnd* pParent,UINT nID);
public:
	AFCYearObj *pObj;
	int nCurYear;
	AFCDayObj *pCurDay;
	void SaveData(CString str);
	// Operations
public:
	void SetDaysBackColor(COLORREF cr) {crBackColor = cr;};
	void SetDaysTextColor(COLORREF cr) { crTextColor = cr;};
	void SetBorderColor(COLORREF cr)   { crBorder = cr;};
	void SetYearBackColor(COLORREF cr) { crTitle = cr;};
	void SetYearBarColor(COLORREF cr)  {crTitleTextColor = cr;};
	void SetWeekBarColor(COLORREF cr)  {crCaptionColor = cr;};
protected:
	COLORREF crBackColor;
	COLORREF crTextColor;
	COLORREF crBorder;
	COLORREF crTitle;
	COLORREF crTitleTextColor;
	COLORREF crCaptionColor;
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(AFCYearSelectWnd)
	//}}AFX_VIRTUAL
	
	// Implementation
public:
	virtual ~AFCYearSelectWnd();
	
	// Generated message map functions
protected:
	//{{AFX_MSG(AFCYearSelectWnd)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AFCYEARSELECTWND_H__E0BC67CC_5483_11DC_A3BF_D4AD141DC353__INCLUDED_)
